function love.load()
	love.window.setTitle("Ascii thing")
	
	--Lucida Console, since all characters are the same size...
	font = love.graphics.newFont("font.ttf", 12)
	love.graphics.setFont(font)
	glyphs = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'\"!@#$%&*()-_=+[]{}~^\\|,<.>;:/? "
	colors = {}
	love.window.setMode(font:getWidth("a"), font:getHeight())
	love.graphics.setBackgroundColor(255, 255, 255, 255)
	for i = 1, string.len(glyphs) do
		local v = string.sub(glyphs, i, i)
		print("char = " .. i .. ", \" " .. v .. " \"")
		love.graphics.clear()
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.rectangle("fill", 0, 0, font:getWidth("a"), font:getHeight())
		love.graphics.setColor(0, 0, 0, 255)
		love.graphics.print(v, 0, 0)
		local imgDt = love.graphics.newScreenshot()
		--love.graphics.present()
		local t = blur(imgDt, 0, 0, font:getWidth("a")-1, font:getHeight()-1)
		table.insert(colors, (t[1]+t[2]+t[3])/3)
	end
	
	image = love.image.newImageData("image.png")
	love.window.setMode(image:getWidth(), image:getHeight())
	
	mode = 1
	text = ""
	IMAGETABLE = {}
	for y = 1, math.ceil(image:getHeight()/font:getHeight()) do
		for x = 1, math.ceil(image:getWidth()/font:getWidth("a")) do
			local x = x-1
			local y = y-1
			local w = font:getWidth("a")
			if (x+1)*font:getWidth("a") > image:getWidth()-1 then
				w = image:getWidth()-1 - (x+1)*font:getWidth("a")
			end
			local h = font:getHeight()
			if (y+1)*font:getHeight() > image:getHeight()-1 then
				h = image:getHeight()-1 - (y+1)*font:getHeight()
			end
			
			local c = blur(image, x*font:getWidth("a"), y*font:getHeight(), w, h)
			local smallest = 1
			local n = (c[1]+c[2]+c[3])/3
			table.insert(IMAGETABLE, c)
			for i = 1, #colors do
				if math.abs(n - colors[i]) < math.abs(n - colors[smallest]) then
					smallest = i
				end
			end
			
			text = text .. string.sub(glyphs, smallest, smallest)
		end
		text = text .. "\n"
	end
	
	image = love.graphics.newImage(image)
end

function love.draw()
	if mode == 1 then
		love.graphics.setColor(0, 0, 0, 255)
		love.graphics.print(text, 0, 0)
	elseif mode == 2 then
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(image, 0, 0)
	elseif mode == 3 then
		local ii = 0
		for y = 1, math.ceil(image:getHeight()/font:getHeight()) do
			for x = 1, math.ceil(image:getWidth()/font:getWidth("a")) do
				ii = ii+1
				local v = IMAGETABLE[ii]
				love.graphics.setColor(v)
				love.graphics.rectangle("fill", (x-1)*font:getWidth("a"), (y-1)*font:getHeight(), font:getWidth("a"), font:getHeight())
			end
		end
	end
end

function blur(imgdt, x, y, w, h)
	local c = {0, 0, 0, 255}
	for xx = x, x+w-1 do
		for yy = y, y+h-1 do
			local cc = {imgdt:getPixel(xx, yy)}
			for i = 1, #c-1 do
				c[i] = c[i]+cc[i]
			end
		end
	end
	for i = 1, #c-1 do
		c[i] = c[i]/(w*h)
	end
	return c
end

function love.keypressed(key)
	if (key == "tab" and (love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift"))) or key == "d" or key == "right" then
		mode = mode - 1
		if mode < 1 then mode = 3 end
	elseif key == "tab" or key == "a" or key == "left" then
		mode = mode + 1
		if mode > 3 then mode = 1 end
	elseif key == "escape" then
		love.event.quit()
	end
end